var index = 205; // 移动距离
var curNum = 0;  //初始左移距离
$(function(){
	$(".menu ul li h2").click(function(){
	  $(this).next().slideToggle(200).parent().siblings().find(".mson").slideUp(200);	
	  $(this).parent().toggleClass("on"); 
  	})
	$(".menu .mson a").click(function(){
		clickLeftMenuA(this)
	})	
	$(".meminfo").hover(function(){
		$(this).find(".memson").show();
		$(this).find(".p1").addClass("on");
	},function(){
		$(this).find(".memson").hide();
		$(this).find(".p1").removeClass("on");
	})
	$(".showmenu").click(function(){
		$(".menu").toggleClass("show");
	})	
	
	initTabStorage(); //初始化保存缓存TAB菜单
	loadTabStorge();  //从缓存中加载TAB菜单
	
	//单击左侧菜单添加TAB标签
	$(".menu .mson p a").click(function(){
		$(".main").hide();
		var href = $(this).attr("href");
		var print_text = $(this).parent().parent().prev().find("a").text();		
		var text = $(this).text();
		if(text=='内容列表'){ text = print_text+'【列表】'; }
		else if(text=='添加内容'){ text = print_text+'【添加】'; }
		else if(text=='分类管理'){ text = print_text+'【分类】'; }
		var flag = false;
		var liIndex;
		var menu = [{'href':href,'text':text,'class':''}];		
		$(".menutab ul li").each(function(index, element) {
			var href2 = $(".menutab ul li").eq(index).find("a").attr("href");
   if(href2==href){
				flag = true;
				liIndex = index;
			}
  });	
		if(!flag){
			$(".menutab ul li").removeClass("on");
			var html = '<li class="on"><span><a href="'+href+'" target="main">'+text+'</a><em></em></span></li>';					
			$(".menutab ul").append(html);			
			var lasIndex = $(".menutab ul li").last().index();	
			creatMenuScroll(flag,lasIndex);				
		}else{
			$(".menutab ul li").eq(liIndex).addClass("on").siblings().removeClass("on");
			creatMenuScroll(flag,liIndex);
		}		
		saveMenuStorage(menu); //储存MENU	
		changeTabClass(href);  //改变MENU On状态	

		var ifram = document.getElementById("main");
		$(ifram).load(function(){
						$(".main").show();
						$(".main").addClass("syui-up-enter");			
		})

	})
	
	//单击TAB A高亮
	$(".menutab ul").on("click","li a",function(){
	 $(".main").hide();
		var obj = $(this);
		$(obj).parent().parent().addClass("on").siblings().removeClass("on");
		var href = $(obj).attr("href");
		$(".menu .mson a").each(function(index, element) {
			var href2 = $(obj).attr("href");
			if(href2==href){		clickLeftMenuA($(obj),true);	}
		});
		changeTabClass(href); //改变MENU On状态
		var ifram = document.getElementById("main");
		$(ifram).load(function(){
						$(".main").show();							
						$(".main").addClass("syui-up-enter");							
		})
	})
	
	//单个TAB关闭
	$(".menutab ul").on("click","li em",function(){	
		var li  = $(this).parent().parent();
		var inx = li.index();	
		var len = $(".menutab ul li").length;
		var curHref = li.find("a").attr("href");
		if((len-1)==inx){
			closeTabUpdateStore(curHref,'prev');	
			var href = li.prev().find("a").attr("href");		
			$("#main").attr("src",href);
			$(".menutab ul li").eq(inx-1).addClass("on");
			li.remove();			
		}else{
			closeTabUpdateStore(curHref,'last');
			if(li.hasClass("on")){				
				li.remove();
				var last = $(".menutab ul li").last();
				var href2 = last.find("a").attr("href");
				$("#main").attr("src",href2);
				last.addClass("on");
			}else{
				li.remove();	
			}
		}
		if(len==2){
		  $(".menutab ul").width("100%"); 	
		}else{
		  initTabW();	
		}
	})
	
	//关闭所有TAB
	$(".closeMenu").click(function(){
		$(".menutab ul li").each(function(i) {
    if(i!=0){ $(this).remove(); }
  })
		$(".menutab ul li").eq(0).addClass("on");
		var href = $(".menutab ul li").eq(0).find("a").attr("href");
		$("#main").attr("src",href);
		$(".menutab ul").css("width","100%");
		$(".menu li").removeClass("on");
		$(".menu .mson").slideUp(200);
		$(".menu .mson a").removeClass("on");
		window.localStorage.removeItem("menu");
		initTabStorage();
	})	
})

//初始化存储TAB
function initTabStorage(){
	var homeUrl = $("#main").attr("homeUrl");
	var data = [{'href':homeUrl,'text':'后台首页','class':'on'}]; 	//默认首页修改位置 
	var local = window.localStorage;
	var menu = JSON.parse(local.getItem('menu'));
	var isadd = true;
	if(menu){
		for(var i = 0; i< menu.length; i++){
			if(menu[i].href==data[0].href){
				isadd = false;
			}
		}
	}
	if(isadd){		
		local.setItem('menu',JSON.stringify(data));
		$("#main").attr("src",homeUrl);	//默认首页修改位置 
	}		
}

//从缓存中加载TAB
function loadTabStorge(){
	var local = window.localStorage;
	var menu  = JSON.parse(local.getItem('menu'));
	var html  = ""
	if(menu){
		for(var i = 0; i < menu.length; i++){
			if(menu[i].class=="on"){
				$(".menu .mson a").each(function(index, element) {
					var href2 = $(this).attr("href");
					if(href2==menu[i].href){
						clickLeftMenuA($(this),true);
					}
				});
				$("#main").attr("src",menu[i].href);
			}
			if(i==0){
			 	html = '<li class='+menu[i].class+'><span><a href="'+menu[i].href+'" target="main">'+menu[i].text+'</a></span></li>';
			}else{				
			 	html = '<li class='+menu[i].class+'><span><a href="'+menu[i].href+'" target="main">'+menu[i].text+'</a><em></em></span></li>';
			}
			$(".menutab ul").append(html);
		}		
		if(menu.length>1){
			initTabW();
		}
	}
}

//将菜单保存到缓存
function saveMenuStorage(data){
	var local = window.localStorage;
	var menu = JSON.parse(local.getItem('menu'));
	var isadd = true;
	if(menu.length>0){
		for(var i = 0; i< menu.length; i++){
			if(menu[i].href==data[0].href){	
				isadd = false;
			}
		}
	}
	if(isadd){
		data = menu.concat(data);
		local.setItem('menu',JSON.stringify(data));
	}
}

//改变TAB当前选中状态
function changeTabClass(href){
	var local = window.localStorage;
	var data = JSON.parse(local.getItem('menu'));
	for(var i = 0; i< data.length; i++){
		if(data[i].href==href){
			data[i].class = "on";
		}else{
			data[i].class = "";
		}
	}
	local.setItem('menu',JSON.stringify(data));
}

//关闭单个TAB时更新缓存菜单
function closeTabUpdateStore(href,flag){
	var local = window.localStorage;
	var data = JSON.parse(local.getItem('menu'));
	for(var i = 0; i< data.length; i++){
		if(data[i].href==href){
			if(flag=="prev"){
				data[i-1].class = "on";
			}else{
				data[data.length-1].class="on";
			}
			data.splice(i, 1);
		}
	}	
	local.setItem('menu',JSON.stringify(data));
}

//点击左侧菜单A标签
function clickLeftMenuA(obj,tab){
	$(".menu .mson a").removeClass("on");
	$(obj).addClass("on");
	var txt1 = $(obj).parent().parent().parent().find("h2 a").text();
	var txt2 = $(obj).text();
	$(".location .s1").text(txt1);
	$(".location .s2").text(txt2);
	$(".menu").removeClass("show");
	if(tab){
	  $(obj).parent().parent().parent().find(".mson").slideDown(200).parent().siblings().find(".mson").slideUp(200);	
	  $(obj).parent().parent().parent().toggleClass("on"); 
	}
}

//初始化TAB宽
function initTabW(){
	var length = $(".menutab ul li").length;
	var ulWidth = 0;
	$(".menutab ul li").each(function(i, element) {
		var liw = $(".menutab ul li").eq(i).width();
		ulWidth+=liw;
    });	
	$(".menutab ul").width(ulWidth);
}

//点击左右按钮移动
function scrollMenu(f){
	var	bdWidth = $(".menutab .bd").width();
	var ulWidth = $(".menutab .bd ul").width();		
	var posLeft = $(".menutab .bd ul").position().left;
		posLeft = Math.abs(posLeft);
		if(ulWidth>bdWidth){
			if(f == "left"){
				posLeft = posLeft - index;
				if(posLeft<index){ posLeft = 0;}
				$(".menutab .bd ul").animate({"left":'-'+posLeft+'px'},300);			
			}else{					
				if(ulWidth - posLeft <= bdWidth+index){					
					posLeft = posLeft;
				}else{
					posLeft = posLeft + index;		
				}			
				$(".menutab .bd ul").animate({"left":'-'+posLeft+'px'},300);
			}
		}
}

//创建TAB时移动
function creatMenuScroll(f,i){
	initTabW();
	var	bdWidth = $(".menutab .bd").width();
	var ulWidth = $(".menutab .bd ul").width();	
	var lastliW = $(".menutab .bd ul li").last().width();		
	if(ulWidth>bdWidth){
		if(f){	
		    var liW = 0;	    
			for(var a = 0; a <= i; a++){
				var cw = $(".menutab .bd ul li").eq(a).width(); 
				liW += cw;
			}
			var curliw = $(".menutab .bd ul li").eq(i).width();
			liW = liW - curliw;		
			$(".menutab .bd ul").animate({"left":'-'+liW+'px'},300);
		}else{
			curNum = ulWidth-bdWidth;
			$(".menutab .bd ul").animate({"left":'-'+curNum+'px'},300);
		}
	}	
}